# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from samplehc import SampleHealthcare, AsyncSampleHealthcare
from tests.utils import assert_matches_type
from samplehc.types.v2.documents import PdfTemplateRetrieveMetadataResponse

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestPdfTemplate:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    def test_method_retrieve_metadata(self, client: SampleHealthcare) -> None:
        pdf_template = client.v2.documents.pdf_template.retrieve_metadata(
            "slug",
        )
        assert_matches_type(PdfTemplateRetrieveMetadataResponse, pdf_template, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_raw_response_retrieve_metadata(self, client: SampleHealthcare) -> None:
        response = client.v2.documents.pdf_template.with_raw_response.retrieve_metadata(
            "slug",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        pdf_template = response.parse()
        assert_matches_type(PdfTemplateRetrieveMetadataResponse, pdf_template, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_streaming_response_retrieve_metadata(self, client: SampleHealthcare) -> None:
        with client.v2.documents.pdf_template.with_streaming_response.retrieve_metadata(
            "slug",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            pdf_template = response.parse()
            assert_matches_type(PdfTemplateRetrieveMetadataResponse, pdf_template, path=["response"])

        assert cast(Any, response.is_closed) is True

    @pytest.mark.skip()
    @parametrize
    def test_path_params_retrieve_metadata(self, client: SampleHealthcare) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `slug` but received ''"):
            client.v2.documents.pdf_template.with_raw_response.retrieve_metadata(
                "",
            )


class TestAsyncPdfTemplate:
    parametrize = pytest.mark.parametrize(
        "async_client", [False, True, {"http_client": "aiohttp"}], indirect=True, ids=["loose", "strict", "aiohttp"]
    )

    @pytest.mark.skip()
    @parametrize
    async def test_method_retrieve_metadata(self, async_client: AsyncSampleHealthcare) -> None:
        pdf_template = await async_client.v2.documents.pdf_template.retrieve_metadata(
            "slug",
        )
        assert_matches_type(PdfTemplateRetrieveMetadataResponse, pdf_template, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_raw_response_retrieve_metadata(self, async_client: AsyncSampleHealthcare) -> None:
        response = await async_client.v2.documents.pdf_template.with_raw_response.retrieve_metadata(
            "slug",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        pdf_template = await response.parse()
        assert_matches_type(PdfTemplateRetrieveMetadataResponse, pdf_template, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_streaming_response_retrieve_metadata(self, async_client: AsyncSampleHealthcare) -> None:
        async with async_client.v2.documents.pdf_template.with_streaming_response.retrieve_metadata(
            "slug",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            pdf_template = await response.parse()
            assert_matches_type(PdfTemplateRetrieveMetadataResponse, pdf_template, path=["response"])

        assert cast(Any, response.is_closed) is True

    @pytest.mark.skip()
    @parametrize
    async def test_path_params_retrieve_metadata(self, async_client: AsyncSampleHealthcare) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `slug` but received ''"):
            await async_client.v2.documents.pdf_template.with_raw_response.retrieve_metadata(
                "",
            )
